/*
 * File: EnigmaModel.java
 * ----------------------
 * This class defines the starter version of the EnigmaModel class,
 * which doesn't implement any of the methods.
 */

package edu.willamette.cs1.enigma;

import static edu.willamette.cs1.enigma.EnigmaConstants.*;

import java.util.ArrayList;

public class EnigmaModel {

    public EnigmaModel() {
        views = new ArrayList<EnigmaView>();
    }

/**
 * Adds a view to this model.
 *
 * @param view The view being added
 */

    public void addView(EnigmaView view) {
        views.add(view);
    }

/**
 * Sends an update request to all the views.
 */

    public void update() {
        for (EnigmaView view : views) {
            view.update();
        }
    }

/**
 * Returns true if the specified letter key is pressed.
 *
 * @param letter The letter key being tested as a one-character string.
 */

    public boolean isKeyDown(String letter) {
        return false;
    }

/**
 * Returns true if the specified lamp is lit.
 *
 * @param letter The lamp being tested as a one-character string.
 */

    public boolean isLampOn(String letter) {
        return false;
    }

/**
 * Returns the letter visible through the rotor at the specified inded.
 *
 * @param index The index of the rotor (0-2)
 * @return The letter visible in the indicated rotor
 */

    public String getRotorLetter(int index) {
        return "A";
    }

/**
 * Called automatically by the view when the specified key is pressed.
 *
 * @param key The key the user pressed as a one-character string
 */

    public void keyPressed(String key) {
        // Write the code to handle a key press
    }

/**
 * Called automatically by the view when the specified key is released.
 *
 * @param key The key the user released as a one-character string
 */

    public void keyReleased(String key) {
        // Write the code to handle a key release
    }

/**
 * Called automatically by the view when the rotor at the specified
 * index (0-2) is clicked.
 *
 * @param index The index of the rotor that was clicked
 */

    public void rotorClicked(int index) {
        // Write the code to run when the specified rotor is clicked
    }

/* Main program */

    public static void main(String[] args) {
        EnigmaModel model = new EnigmaModel();
        EnigmaView view = new EnigmaView(model);
        model.addView(view);
    }

/* Private instance variables */

    private ArrayList<EnigmaView> views;
    
}
